Vue.component("genome-viewer",{
  template: `
    <div>
      <!--<div class="container-lin-dna">
        <div :id="genomeStats.id" class="lin-dna" :data-cluster-start="genomeStats.start" :data-cluster-end="genomeStats.end" style="width: 100%; height: 50px;">
          <div v-for="feature in featureData" :key="feature.name" class="region-to-display" :data-region-name="feature.name" :data-region-description="feature.description" :data-region-start="feature.start" :data-region-end="feature.end" :data-region-strand="feature.strand" :data-region-type="feature.type">
          </div>
        </div>
      </div>
      -->
      <svg id="genome-vuer" ref="genomeVuer" :height="height" :width="width">
        <axis :xOffset="to_w(0)" :vOffset="to_h()" :height="one_height" :width="to_w(100)" :start="100" :stop="1000" :genomeSize="10000">
        </axis>
        <lane v-for="lane in lanes" :key="lane.id" :x="to_w(0)" :y="to_h(lane)" :height="2*one_height" :width="to_w(100)">
        </lane>
        <feature v-for="(feature, index) in featureData" :key="feature.name" :feature-id="feature.name" :svg-width="(1+index)*20" :svg-height="(1+index)*10" :svg-x="10+(index%2 * 400)" :svg-y="index*100+10" color="grey" border-color="red" @click="featureClick">
        </feature>
      </svg>
    </div>`,
  props: {
    genomeStats: {
      validator (value) {
        for (let property of ['id', 'start', 'end']) {
          if (!value.hasOwnProperty(property)) {
            return false
          }
        }
        return true
      }
    },
    featureData: {
      validator (value) {
        for (let feature of value) {
          for (let property of ['name', 'description', 'start', 'end', 'strand', 'type']) {
            if (!feature.hasOwnProperty(property)) {
              return false
            }
          }
          return true
        }
      }
    },
    height: {},
    width: {},
  },
  computed:{
    axis_start(){},
    axis_end(){},
    genome_size(){},
    length(){
      if(this.genomeStats.start < this.genomeStats.end){
        return this.genomeStats.end - this.genomeStats.start
      }else{
        // TODO: if genome is circular
      }
    },
    one_height(){
      return this.height/(1 + 2 * this.lanes.length)
    },
  },
  mounted() {
      //this.height / length([axis and lanes * 2])
      // lanes are twize as big as the axis
      // so height / (1 + no_of_lanes * 2)
      //var one_height = this.svg_size[1]/(1 + 2 * this.lanes.length)
      //let svg_el = this.$refs.genomeVuer.getBoundingClientRect()
      //console.log(svg_el)
      ////console.log(svg_el)
      //this.width = svg_el.width
      //this.height = svg_el.height
      ////return [svg_el.clientWidth, svg_el.clientHeight]
      //this.one_height = this.height/(1 + 2 * this.lanes.length)
    
    },
  methods:{
    to_h(param){
        //param is a value between -n and +n, where n is the number of lanes divided by 2
        //if param is 0 => axis
        //if param < 0 => lane on top
        //if param > 0 => lane on bottom
        let zero = this.lanes.length * this.one_height
        if(param < 0){
          return zero + 2 * this.one_height * (param)
        }else if(param > 0){
          return zero + this.one_height * (param)
        }
        return zero
      },
    to_w(param){
      //param is a value between 0 and 100, where 100 is the full length of the svg
      return (this.width*param)/100
      },
    featureClick (featureId) {
      console.log(featureId)
    }
  },
  data: function(){
    return {
      lanes: [-1, 1],
    }
  },
})
